% function plot_map( h_map, op, oa, grid, gcs, ng, fov )
% input:
%   h_map .. map figure handle
%   op .. observer point
%   oa .. observer view vector angle
%   grid .. maze grid
%   gcs .. grid cell sizes
%   ng .. grid sizes
%   fov .. field of view information, contains rendered image
function plot_map( h_map, op, oa, grid, gcs, ng, fov )
global g_angle

  % Plot grid cells.
  figure( h_map );
  clf
  hold on
  axis equal
  for j = 0:ng(2)-1
    for i = 0:ng(1)-1
      xx = [i * gcs(1), (i + 1) * gcs(1), (i + 1) * gcs(1), i * gcs(1)];
      yy = [j * gcs(2), j * gcs(2), (j + 1) * gcs(2), (j + 1) * gcs(2)];
      fill( xx, yy, grid(j+1,i+1) );
    end
  end

  % Plot observer point and direction.
  oaa = oa * pi / 180;
  ov = [cos(oaa), -sin(oaa); sin(oaa), cos(oaa)] * [1; 0];
  plot( op(1), op(2), 'gx' );
  plot( [op(1), op(1) + gcs(1) * ov(1)], [op(2), op(2) + gcs(1) * ov(2)], 'g' );

  for i = 1:fov.s(1)
    oaa = oa + g_angle(i);
    [ok, li, cp, tc] = trace_ray( oaa, op, grid, gcs, ng );
    % Plot line of view.
    if (ok & ~mod( round( oaa ), 2 ))
      plot( li(1), li(2), 'yo' );
      plot( [op(1) li(1)], [op(2), li(2)], 'y:' );
    end
  end
  